/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.blackmarket.utils.BlackMarketUtils
 *  fire.pb.fushi.Module
 *  fire.pb.http.cbg.CBGHttpUtils
 *  fire.pb.http.cbg.CBGOrderDownHttpCallBackHandler
 *  fire.pb.http.cbg.CBGOrderUpHttpCallBackHandler
 *  fire.pb.item.AddItemResult
 *  fire.pb.item.ItemBase
 *  fire.pb.item.ItemMaps
 *  fire.pb.item.Module
 *  fire.pb.item.Pack
 *  fire.pb.main.Gs
 *  fire.pb.pet.Pet
 *  fire.pb.pet.PetColumn
 *  fire.pb.pet.SPetError
 *  fire.pb.shop.GoldOrder
 *  fire.pb.shop.SGoldOrderBrowseBlackMarket
 *  fire.pb.shop.SRefreshGoldOrderState
 *  fire.pb.shop.utils.MarketUtils
 *  fire.pb.talk.MessageMgr
 *  fire.pb.tel.utils.CheckCodeUtils
 *  mkdb.Procedure
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.GoldOrder
 *  xbean.Pod
 *  xbean.RoleBlackMarket
 *  xtable.Blackmarkettab
 *  xtable.Orderidtab
 */
package fire.pb.blackmarket.srv;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.blackmarket.utils.BlackMarketUtils;
import fire.pb.http.cbg.CBGHttpUtils;
import fire.pb.http.cbg.CBGOrderDownHttpCallBackHandler;
import fire.pb.http.cbg.CBGOrderUpHttpCallBackHandler;
import fire.pb.item.AddItemResult;
import fire.pb.item.ItemBase;
import fire.pb.item.ItemMaps;
import fire.pb.item.Module;
import fire.pb.item.Pack;
import fire.pb.main.Gs;
import fire.pb.pet.Pet;
import fire.pb.pet.PetColumn;
import fire.pb.pet.SPetError;
import fire.pb.shop.SGoldOrderBrowseBlackMarket;
import fire.pb.shop.SRefreshGoldOrderState;
import fire.pb.shop.utils.MarketUtils;
import fire.pb.talk.MessageMgr;
import fire.pb.tel.utils.CheckCodeUtils;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Map;
import java.util.concurrent.Future;
import mkdb.Procedure;
import mkio.Protocol;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.concurrent.FutureCallback;
import org.apache.log4j.Logger;
import xbean.GoldOrder;
import xbean.Pod;
import xbean.RoleBlackMarket;
import xtable.Blackmarkettab;
import xtable.Orderidtab;

public class BlackMarketManager {
    public static final Logger LOG = Logger.getLogger((String)"BLACKMARKET");

    public static BlackMarketManager getInstance() {
        return BlackMarketManagerHolder.instance;
    }

    public boolean goldOrderUp(long roleId, long gold, long rmb) {
        if (!CheckCodeUtils.isCanUpByCJG((long)roleId)) {
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(roleId).append(",藏金阁上架的时候没有进行短信验证");
            LOG.error((Object)sbd.toString());
            return false;
        }
        if (gold < BlackMarketUtils.getMinGold() || rmb < BlackMarketUtils.getMinRMB() || gold > BlackMarketUtils.getMaxGold() || rmb > BlackMarketUtils.getMaxRMB()) {
            LOG.error((Object)("role=" + roleId + ", 金币订单上架错误：gold=" + gold + ", rmb=" + rmb + ", 输入的金币数量或RMB数量不在指定范围内！"));
            return false;
        }
        Pack pack = new Pack(roleId, false);
        long goldNubmer = pack.getCurrency(2);
        if (goldNubmer - gold < 0L) {
            LOG.error((Object)("role=" + roleId + ", 金币不足！"));
            return false;
        }
        if ((float)pack.getCurrency(13) + (float)gold * fire.pb.fushi.Module.getCreditPointValue((int)26) < 0.0f) {
            LOG.error((Object)("role=" + roleId + ", 信用值不足！"));
            MessageMgr.sendMsgNotify((long)roleId, (int)162194, null);
            return false;
        }
        long costGold = pack.subGold(-gold, "", YYLoggerTuJingEnum.tujing_Value_balckmarket, 1);
        if (costGold != -gold) {
            LOG.error((Object)("role=" + roleId + ", 金币订单上架错误, 扣金币失败！"));
            return false;
        }
        pack.addSysCurrency((long)((float)gold * fire.pb.fushi.Module.getCreditPointValue((int)26)), 13, "金币订单上架\t", YYLoggerTuJingEnum.tujing_Value_balckmarket, 0);
        RoleBlackMarket roleBlackMarket = Blackmarkettab.get((Long)roleId);
        if (null == roleBlackMarket) {
            roleBlackMarket = Pod.newRoleBlackMarket();
            Blackmarkettab.insert((Long)roleId, (RoleBlackMarket)roleBlackMarket);
        }
        if (roleBlackMarket.getGoldordersale().size() > 0) {
            int maxOrderUpNumber = 0;
            for (GoldOrder order : roleBlackMarket.getGoldordersale().values()) {
                if (order.getState() != 1) continue;
                ++maxOrderUpNumber;
            }
            if (maxOrderUpNumber == BlackMarketUtils.getMaxOrderUpNumber()) {
                MessageMgr.sendMsgNotify((long)roleId, (int)162188, null);
                LOG.error((Object)("role=" + roleId + ", orderUpNumber=" + maxOrderUpNumber + ", 上架金币订单数量超出, 新金币订单上架失败！"));
                return false;
            }
        }
        long now = System.currentTimeMillis();
        long pid = Orderidtab.nextKey();
        GoldOrder order = Pod.newGoldOrder();
        order.setPid(pid);
        order.setNumber(gold);
        order.setPrice(rmb);
        order.setPublicity(0);
        order.setTime(now);
        order.setState(0);
        if (LOG.isInfoEnabled()) {
            LOG.info((Object)("上架金币订单：role=" + roleId + ", pid=" + pid + ", gold=" + gold + ", price=" + rmb));
        }
        roleBlackMarket.getGoldordersale().put(pid, order);
        HttpPost orderPost = CBGHttpUtils.genItemUpHttpPostRequest((long)roleId, (long)rmb, (long)gold, (String)Long.toString(pid), (int)0, (int)1, null);
        if (orderPost == null) {
            LOG.error((Object)new StringBuilder("role=").append(roleId).append(", 生成平台订单发送对象失败！"));
            return false;
        }
        Future done = Gs.getHttpClient().execute((HttpUriRequest)orderPost, (FutureCallback)new CBGOrderUpHttpCallBackHandler(roleId, pid, 1));
        return true;
    }

    public boolean goldOrderDown(long roleId, long pid) {
        Pack pack = new Pack(roleId, false);
        long goldNubmer = pack.getCurrency(2);
        if (goldNubmer >= Long.MAX_VALUE) {
            LOG.error((Object)("role=" + roleId + ", gold=" + goldNubmer + ", 再添加金币就溢出了！"));
            MessageMgr.sendMsgNotify((long)roleId, (int)162187, null);
            return false;
        }
        HttpPost orderPost = CBGHttpUtils.genItemDownHttpPostRequest((long)roleId, (String)Long.toString(pid));
        if (orderPost == null) {
            LOG.error((Object)("role=" + roleId + ", 生成平台订单发送对象失败！"));
            return false;
        }
        Future done = Gs.getHttpClient().execute((HttpUriRequest)orderPost, (FutureCallback)new CBGOrderDownHttpCallBackHandler(roleId, pid, 1));
        return true;
    }

    public void goldOrderTrade(final long buyerRoleId, final long sellerRoleId, final long pid) {
        new Procedure(){

            protected boolean process() throws Exception {
                RoleBlackMarket sellerRoleBlackMarket = Blackmarkettab.get((Long)sellerRoleId);
                if (null == sellerRoleBlackMarket) {
                    LOG.error((Object)("role=" + sellerRoleId + ", pid=" + pid + ", orderType=" + 1 + ", 黑市订单表中不存在此角色信息, 有错误！"));
                    return false;
                }
                GoldOrder goldOrder = (GoldOrder)sellerRoleBlackMarket.getGoldordersale().get(pid);
                if (null == goldOrder) {
                    LOG.error((Object)("role=" + sellerRoleId + ", pid=" + pid + ", orderType=" + 1 + ", 黑市订单表中不存在此角色信息, 有错误！"));
                    return false;
                }
                int orderState = goldOrder.getState();
                if (orderState != 1) {
                    LOG.error((Object)("role=" + sellerRoleId + ", pid=" + pid + ", orderType=" + 1 + ", order state=" + orderState + ", 订单状态非法."));
                    return false;
                }
                goldOrder.setState(3);
                SRefreshGoldOrderState refreshSellerOrderState = new SRefreshGoldOrderState(goldOrder.getPid(), goldOrder.getState());
                Procedure.psendWhileCommit((long)sellerRoleId, (Protocol)refreshSellerOrderState);
                MessageMgr.sendSystemMessageToRole((long)sellerRoleId, (int)162181, Arrays.asList(Long.toString(goldOrder.getNumber())));
                RoleBlackMarket buyerRoleBlackMarket = Blackmarkettab.get((Long)buyerRoleId);
                if (null == buyerRoleBlackMarket) {
                    buyerRoleBlackMarket = Pod.newRoleBlackMarket();
                    Blackmarkettab.insert((Long)buyerRoleId, (RoleBlackMarket)buyerRoleBlackMarket);
                }
                long now = System.currentTimeMillis();
                GoldOrder order = Pod.newGoldOrder();
                order.setPid(pid);
                order.setNumber(goldOrder.getNumber());
                order.setPrice(goldOrder.getPrice());
                order.setPublicity(0);
                order.setTime(now);
                order.setState(4);
                buyerRoleBlackMarket.getGoldorderbuy().put(pid, order);
                SRefreshGoldOrderState refreshBuyerState = new SRefreshGoldOrderState(goldOrder.getPid(), order.getState());
                Procedure.psendWhileCommit((long)buyerRoleId, (Protocol)refreshBuyerState);
                MessageMgr.sendSystemMessageToRole((long)buyerRoleId, (int)162182, Arrays.asList(Long.toString(order.getNumber())));
                if (LOG.isInfoEnabled()) {
                    LOG.error((Object)("buyerRoleId=" + buyerRoleId + " 购买 sellerRoleId=" + sellerRoleId + ", pid=" + pid + ", orderType=" + 1 + ", 买家order state=" + order.getState() + ", 卖家order state=" + goldOrder.getState() + ", 交易完成."));
                }
                return true;
            }
        }.submit();
    }

    public boolean goldOrderIsSale(long roleId, long pid) {
        RoleBlackMarket roleBlackMarket = Blackmarkettab.select((Long)roleId);
        if (null == roleBlackMarket) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", 黑市订单表中不存在此角色信息, 有错误！"));
            return false;
        }
        GoldOrder goldOrder = (GoldOrder)roleBlackMarket.getGoldordersale().get(pid);
        if (null == goldOrder) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", 角色售卖表中不存在此订单！"));
            return false;
        }
        int orderState = goldOrder.getState();
        if (orderState != 1) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", order state=" + orderState + ", 订单状态非法."));
            return false;
        }
        if (LOG.isInfoEnabled()) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", order state=" + orderState + ", 可以出售."));
        }
        return true;
    }

    public boolean goldOrderTakeOut(long roleId, long pid) {
        Pack pack = new Pack(roleId, false);
        long goldNubmer = pack.getCurrency(2);
        if (goldNubmer >= Long.MAX_VALUE) {
            LOG.error((Object)("role=" + roleId + ", gold=" + goldNubmer + ", 再添加金币就溢出了！"));
            MessageMgr.sendMsgNotify((long)roleId, (int)162186, null);
            return false;
        }
        RoleBlackMarket roleBlackMarket = Blackmarkettab.get((Long)roleId);
        if (null == roleBlackMarket) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", 黑市订单表中不存在此角色信息, 有错误！"));
            return false;
        }
        GoldOrder goldOrder = (GoldOrder)roleBlackMarket.getGoldorderbuy().get(pid);
        if (null == goldOrder) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", 角色售卖表中不存在此订单！"));
            return false;
        }
        int orderState = goldOrder.getState();
        if (orderState != 4) {
            LOG.error((Object)("role=" + roleId + ", pid=" + pid + ", orderType=" + 1 + ", order state=" + orderState + ", 订单状态非法."));
            return false;
        }
        goldOrder.setState(5);
        long goldNumber = goldOrder.getNumber();
        long backGold = pack.addSysGold(goldNumber, "", YYLoggerTuJingEnum.tujing_Value_balckmarket, 1);
        if (LOG.isInfoEnabled()) {
            LOG.info((Object)("role=" + roleId + ", pid=" + pid + ", gold=" + backGold + ", 取回金币订单中的金币！"));
        }
        pack.addSysCurrency((long)((float)goldNumber * fire.pb.fushi.Module.getCreditPointValue((int)27)), 13, "藏宝阁取回金币订单中的金币", YYLoggerTuJingEnum.tujing_Value_balckmarket, 0);
        SRefreshGoldOrderState refreshState = new SRefreshGoldOrderState(goldOrder.getPid(), goldOrder.getState());
        Procedure.psendWhileCommit((long)roleId, (Protocol)refreshState);
        return true;
    }

    public boolean goldOrderBrowse(long roleId) {
        fire.pb.shop.GoldOrder order;
        int maxOrderLstNumber;
        RoleBlackMarket roleBlackMarket = Blackmarkettab.select((Long)roleId);
        if (null == roleBlackMarket) {
            LOG.error((Object)("role=" + roleId + ", orderType=" + 1 + ", 黑市订单表中不存在此角色信息！"));
            return false;
        }
        Map goldOrderBuyMap = roleBlackMarket.getGoldorderbuy();
        Map goldOrderSaleMap = roleBlackMarket.getGoldordersale();
        ArrayList<fire.pb.shop.GoldOrder> buyList = new ArrayList<fire.pb.shop.GoldOrder>(10);
        ArrayList<fire.pb.shop.GoldOrder> saleList = new ArrayList<fire.pb.shop.GoldOrder>(10);
        if (goldOrderBuyMap.size() > 0) {
            maxOrderLstNumber = 0;
            for (GoldOrder xbeanGoldOrder : goldOrderBuyMap.values()) {
                order = BlackMarketUtils.xbeanGoldOrderCopyGoldOrder((GoldOrder)xbeanGoldOrder);
                buyList.add(order);
                if (LOG.isInfoEnabled()) {
                    LOG.info((Object)new StringBuilder("金币购买订单：").append(order.toString()));
                }
                if (++maxOrderLstNumber <= BlackMarketUtils.getMaxOrderLstNumber()) continue;
                break;
            }
            Collections.sort(buyList, new Comparator<fire.pb.shop.GoldOrder>(){

                @Override
                public int compare(fire.pb.shop.GoldOrder o1, fire.pb.shop.GoldOrder o2) {
                    return Long.signum(o2.time - o1.time);
                }
            });
        }
        if (goldOrderSaleMap.size() > 0) {
            maxOrderLstNumber = 0;
            for (GoldOrder xbeanGoldOrder : goldOrderSaleMap.values()) {
                order = BlackMarketUtils.xbeanGoldOrderCopyGoldOrder((GoldOrder)xbeanGoldOrder);
                saleList.add(order);
                if (LOG.isInfoEnabled()) {
                    LOG.info((Object)new StringBuilder("金币售卖订单：").append(order.toString()));
                }
                if (++maxOrderLstNumber <= BlackMarketUtils.getMaxOrderLstNumber()) continue;
                break;
            }
            Collections.sort(saleList, new Comparator<fire.pb.shop.GoldOrder>(){

                @Override
                public int compare(fire.pb.shop.GoldOrder o1, fire.pb.shop.GoldOrder o2) {
                    return Long.signum(o2.time - o1.time);
                }
            });
        }
        SGoldOrderBrowseBlackMarket goldOrderBrowse = new SGoldOrderBrowseBlackMarket(saleList, buyList);
        Procedure.psendWhileCommit((long)roleId, (Protocol)goldOrderBrowse);
        return true;
    }

    private ItemBase itemOrderUp(long roleId, int key, int number) {
        boolean succ;
        long currTime;
        ItemMaps srcbag = Module.getInstance().getItemMaps(roleId, 1, false);
        ItemMaps destbag = Module.getInstance().getItemMaps(roleId, 7, false);
        ItemBase upItem = srcbag.TransOut(key, number, "从背包移动道具到黑市中");
        if (upItem == null) {
            LOG.error((Object)("role=" + roleId + ", 上架道具在背包容器中不存在！"));
            return null;
        }
        long freezeTime = upItem.getDataItem().getMarkettime();
        if (freezeTime > 0L && (currTime = System.currentTimeMillis()) < freezeTime) {
            LOG.error((Object)("role=" + roleId + ", 道具id=" + upItem.getItemId() + ", 道具冻结期内不能上架！"));
            return null;
        }
        AddItemResult ret = destbag.doAddItem(upItem, -1, "黑市上架", YYLoggerTuJingEnum.tujing_Value_balckmarket, 0);
        if (LOG.isInfoEnabled()) {
            LOG.info((Object)("role=" + roleId + ", 将商品上架" + ret));
        }
        if (!(succ = ret.name().equalsIgnoreCase("succ"))) {
            return null;
        }
        return upItem;
    }

    private ItemBase itemOrderDown(long roleId, int key, int number) {
        boolean succ;
        ItemMaps srcbag = Module.getInstance().getItemMaps(roleId, 7, false);
        ItemMaps destbag = Module.getInstance().getItemMaps(roleId, 1, false);
        ItemBase downItem = srcbag.TransOut(key, number, "从黑市移动道具到背包中");
        if (downItem == null) {
            LOG.error((Object)("role=" + roleId + ", 下架道具在黑市容器中不存在 ！"));
            return null;
        }
        AddItemResult ret = destbag.doAddItem(downItem, -1, "黑市下架", YYLoggerTuJingEnum.tujing_Value_balckmarket, 0);
        if (LOG.isInfoEnabled()) {
            LOG.info((Object)("role=" + roleId + ", 将商品下架" + ret));
        }
        if (!(succ = ret.name().equalsIgnoreCase("succ"))) {
            return null;
        }
        return downItem;
    }

    private Object[] itemOrderTrade(long buyRoleId, long saleRoleId, int key, int number) {
        long freezeTimeConf;
        ItemMaps srcbag = Module.getInstance().getItemMaps(saleRoleId, 7, false);
        ItemMaps destbag = Module.getInstance().getItemMaps(buyRoleId, 1, false);
        ItemBase item = srcbag.TransOut(key, number, "黑市中售卖");
        if (item == null) {
            LOG.error((Object)("role=" + buyRoleId + ", 购买role=" + saleRoleId + ", 道具失败！"));
            return new Object[]{false, null};
        }
        if (!MarketUtils.isPayService() && (freezeTimeConf = (long)item.getItemAttr().getSalefreezetime()) > 0L) {
            long currTime = System.currentTimeMillis();
            item.getDataItem().setMarkettime(currTime + (freezeTimeConf *= 86400000L));
        }
        AddItemResult ret = destbag.doAddItem(item, -1, "黑市中购买", YYLoggerTuJingEnum.tujing_Value_balckmarket, 0);
        boolean succ = ret.name().equalsIgnoreCase("succ");
        return new Object[]{succ, item};
    }

    private Pet petOrderUp(long roleId, int key) {
        PetColumn srccol = new PetColumn(roleId, 1, false);
        PetColumn dstcol = new PetColumn(roleId, 6, false);
        Pet pet = srccol.getPet(key);
        if (pet != null && pet.isMarketFreeze()) {
            LOG.error((Object)("role=" + roleId + ", 上架宠物id=" + pet.getBaseId() + ", 宠物冻结期内不能上架！"));
            return null;
        }
        int newKey = PetColumn.doMovePet((PetColumn)srccol, (int)key, (PetColumn)dstcol);
        if (newKey < 0) {
            if (newKey == -6) {
                LOG.error((Object)("role=" + roleId + ", 参战宠物不能上架!"));
            } else {
                LOG.error((Object)("role=" + roleId + ", 宠物不能上架原因" + newKey));
            }
            SPetError errosend = new SPetError(newKey);
            Procedure.psend((long)roleId, (Protocol)errosend);
            return null;
        }
        return dstcol.getPet(newKey);
    }

    private Pet petOrderDown(long roleId, int key) {
        PetColumn srccol = new PetColumn(roleId, 6, false);
        PetColumn dstcol = new PetColumn(roleId, 1, false);
        int newKey = PetColumn.doMovePet((PetColumn)srccol, (int)key, (PetColumn)dstcol);
        if (newKey < 0) {
            LOG.error((Object)("role=" + roleId + ", 宠物不能下架原因" + newKey));
            SPetError errosend = new SPetError(newKey);
            Procedure.psend((long)roleId, (Protocol)errosend);
            return null;
        }
        return dstcol.getPet(newKey);
    }

    private boolean petOrderTrade(long buyRoleId, long saleRoleId, int key) {
        int ret;
        long freezeTime;
        Pet pet;
        PetColumn srccol = new PetColumn(saleRoleId, 6, false);
        PetColumn dstcol = new PetColumn(buyRoleId, 1, false);
        if (!MarketUtils.isPayService() && (pet = srccol.getPet(key)) != null && (freezeTime = (long)pet.getPetAttr().getMarketfreezetime()) > 0L) {
            long currTime = System.currentTimeMillis();
            pet.setMarketFreezeExpire(currTime + (freezeTime *= 86400000L));
        }
        if ((ret = PetColumn.moveBetweenRolePetColumn((PetColumn)srccol, (PetColumn)dstcol, (int)key)) == -1) {
            LOG.error((Object)("role=" + buyRoleId + ", 购买role=" + saleRoleId + ", 宠物失败！"));
            MessageMgr.sendMsgNotify((long)buyRoleId, (int)168001, null);
            return false;
        }
        return ret == 0;
    }

    private static class BlackMarketManagerHolder {
        static BlackMarketManager instance = new BlackMarketManager();

        private BlackMarketManagerHolder() {
        }
    }
}

